/**
 * ---------- ПРИМЕРЫ ES6 --------------- *
 *         деструктуризация               *
 * ------------ МАССИВЫ ----------------- *
 */
// ES5
// var array = [1, 2, 3, 4];
// var first = array[0];
// var third = array[2];
// // 1 3
// console.log(first, third);

// То же самое в ES6
const array = [1, 2, 3, 4];
const [first, , third] = array;
// 1 3
console.log(first, third);

/**
 * ---------- ПРИМЕРЫ ES6 --------------- *
 *         деструктуризация               *
 * ----------- ПЕРЕМЕННЫЕ --------------- *
 */
// // ES5
// var a = 1;
// var b = 2;
// var tmp = a;
// a = b;
// b = tmp;
// // 2 1
// console.log(a, b);

// То же самое в ES6
let a = 1;
let b = 2;
[a, b] = [b, a];
// 2 1
console.log(a, b);

/**
 * ---------- ПРИМЕРЫ ES6 --------------- *
 *         деструктуризация               *
 * ------------ ОБЪЕКТЫ ----------------- *
 */
// пускай у нас есть объект
let ob = { l: 22, b: 45, c: 63 }
// деструктуризация осуществляется по ключу
let { l: new_l, c: new_c } = ob;
console.log(new_l); // 22
console.log(new_c); // 63
// можем переиспользовать названия
// для новых переменных
//let {l:l, c:c} = ob;
// и это будет ровно тоже самое
let { l, c } = ob;
console.log(l); // 22
console.log(c); // 63